-- -------------------------------------------------------------------------- --
-- GroupProgress By Xulos ( EU ALLIANCE YSONDRE )      
-- -------------------------------------------------------------------------- --
--UIPanelWindows["GroupProgressFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };
GroupProgress = {};
GroupProgress.version = GetAddOnMetadata("GroupProgress", "Version");
GroupProgress.BARRES = {};

-- static
function GroupProgressFrame_Init(self)
	GroupProgressDB = GroupProgressDB or {};
	GroupProgressDB.Params = GroupProgressDB.Params or {};
	GroupProgressDB.Params.PlayerBarHeight = 10;
	GroupProgressDB.Params.PlayerBarWidth = 200;
	GroupProgressDB.Params.Showed = GroupProgressDB.Params.Showed or false;
			
	GroupProgress.AddonPrefix = "GPP_"..GroupProgress.version;
	RegisterAddonMessagePrefix(GroupProgress.AddonPrefix);
	
	local localizedClass = "";
	localizedClass, GroupProgress.MyClass = UnitClass("player");
	
	GroupProgressDB.PartyLst = {};
	
	GroupProgressDB.Players = {};
	
	GroupProgress.MyName = UnitName("player");
	GroupProgress:AddPlayerForSharing(GroupProgress.MyName);
	
	if ( GroupProgressDB.Params.Showed == true ) then GroupProgressFrame:Show(); end
end
function GroupProgressMinimapButton_OnClick(self)
    if (GroupProgressFrame) then
        if(GroupProgressFrame:IsVisible() ) then
            GroupProgressFrame:Hide();
			GroupProgressDB.Params.Showed = false;
		else
            GroupProgressFrame:Show();
			GroupProgressDB.Params.Showed = true;
		end
    end
	GroupProgress:SharingXP();
	if ( UnitAffectingCombat("player") == false ) then
		GroupProgress:InitFrame();
		GroupProgress:UpdateFrame();
	end
end
function GroupProgressButtonTemplate_OnLoad(self)
end
function GroupProgressMinimapButton_OnLoad(self)
	GroupProgressMinimapButton.label:SetText("GPP");
end
function GroupProgressMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("GroupProgress "..GroupProgress.version);
end
function GroupProgressMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function GroupProgressBar_OnEnter(self)
	local infos = GroupProgressDB.Players[self.Name];
	if ( infos ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText("GroupProgress "..GroupProgress.version);
		GameTooltip:AddLine("--------");
		GameTooltip:AddDoubleLine("Name :", infos.Name);
		GameTooltip:AddDoubleLine("Class :", infos.Class);
		GameTooltip:AddDoubleLine("Level :", infos.Lvl);
		local EvXPinPercent = GroupProgress:FormatAmountToPercentValue(infos.EventXP, 1, infos.MaxXP);
		GameTooltip:AddDoubleLine("Average Item Level :", infos.iLvl);
		GameTooltip:AddDoubleLine("Last Event XP :", tostring(infos.EventXP).." - "..tostring(EvXPinPercent).."%");
		if ( infos.NRemainEventXP > 0 ) then
			GameTooltip:AddDoubleLine("Next level :", string.format("%.2f", infos.NRemainEventXP).." Events");
		else
			GameTooltip:AddDoubleLine("Next level :", "- Events");
		end
		
		local CurXPPercent = GroupProgress:FormatAmountToPercentValue(infos.CurXP, 1, infos.MaxXP);
		GameTooltip:AddDoubleLine("Current XP :", infos.CurXP.." - "..tostring(CurXPPercent).."%");
		GameTooltip:AddDoubleLine("Maximum XP :", infos.MaxXP);
		local RestXPPercent = GroupProgress:FormatAmountToPercentValue(infos.RestXP, 1, infos.MaxXP);
		GameTooltip:AddDoubleLine("Rested XP :", infos.RestXP.." - "..tostring(RestXPPercent).."%");
		GameTooltip:Show();
	end
end
function GroupProgressBar_OnLeave(self)
	GameTooltip:Hide();
end
function GroupProgressFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("PLAYER_XP_UPDATE");
	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	self:RegisterEvent("CHAT_MSG_ADDON");
	self:RegisterEvent("GROUP_ROSTER_CHANGED");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
end
function GroupProgressFrame_OnEvent(self, event, arg1, arg2, ...)
	if ( event == "VARIABLES_LOADED" ) then
		GroupProgressFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_LEVEL_UP" ) then -- arg1 New player level. Note that UnitLevel("player") will most likely return an incorrect value when called in this event handler or shortly after, so use this value. 
		GroupProgress:XPChangedOfMe(arg1);
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_XP_UPDATE" ) then -- arg1 The UnitId affected, eg: "player" 
		GroupProgress:XPChangedOfMe();
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "CHAT_MSG_COMBAT_XP_GAIN" ) then -- arg1 chat message 
		GroupProgress:XPChangedOfMe();
		GroupProgress:SharingXP();
		GroupProgress:UpdateFrame();
	elseif ( event == "CHAT_MSG_ADDON" ) then -- arg1 prefix arg2 msg arg3 party arg4 sender
		if ( arg1 == GroupProgress.AddonPrefix ) then GroupProgress:SharingReceived(arg2); end
		GroupProgress:UpdateFrame();
	elseif ( event == "GROUP_ROSTER_CHANGED" ) then
		print("GROUP_ROSTER_CHANGED");
		GroupProgress:XPChangedOfMe();
		GroupProgress:SharingXP();
		if ( UnitAffectingCombat("player") == false ) then
			GroupProgress:InitFrame();
		end
		GroupProgress:UpdateFrame();
	elseif ( event == "RAID_ROSTER_UPDATE" ) then
		print("RAID_ROSTER_UPDATE");
		GroupProgress:XPChangedOfMe();
		GroupProgress:SharingXP();
		if ( UnitAffectingCombat("player") == false ) then
			GroupProgress:InitFrame();
		end
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		GroupProgress:XPChangedOfMe();
		GroupProgress:InitFrame();
		GroupProgress:UpdateFrame();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == false ) then
			GroupProgress:XPChangedOfMe();
			GroupProgress:SharingXP();
			GroupProgress:RequestUpdate();
			GroupProgress:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("GroupProgress "..GroupProgress.version.." LOADED");
			GroupProgress:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("GroupProgress "..GroupProgress.version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	end
end
function GroupProgress_RequestUpdate(self)
    GroupProgress:RequestUpdate();
end
-- kernel
function GroupProgress:XPChangedOfMe(arg1) -- ok 
	GroupProgressDB.Players[GroupProgress.MyName] = GroupProgressDB.Players[GroupProgress.MyName] or {};
	GroupProgressDB.Players[GroupProgress.MyName].Name = GroupProgress.MyName;
	local NewXp = UnitXP("player");
	local EventXp = NewXp - (GroupProgressDB.Players[GroupProgress.MyName].CurXP or NewXp);
	if ( EventXp > 0 ) then
		GroupProgressDB.Players[GroupProgress.MyName].EventXP = EventXp;
	else
		GroupProgressDB.Players[GroupProgress.MyName].EventXP = GroupProgressDB.Players[GroupProgress.MyName].EventXP or 0;
	end
	GroupProgressDB.Players[GroupProgress.MyName].CurXP = NewXp;
	local MaxXp = UnitXPMax("player");
	GroupProgressDB.Players[GroupProgress.MyName].MaxXP = MaxXp;
	GroupProgressDB.Players[GroupProgress.MyName].RestXP = GetXPExhaustion() or 0; -- en normal GetXPExhaustion() vaut nil voir http://www.wowwiki.com/API_GetXPExhaustion
	GroupProgressDB.Players[GroupProgress.MyName].Class = GroupProgress.MyClass;
	if ( GroupProgressDB.Players[GroupProgress.MyName].EventXP > 0 ) then
		GroupProgressDB.Players[GroupProgress.MyName].NRemainEventXP = (MaxXp - NewXp)/GroupProgressDB.Players[GroupProgress.MyName].EventXP;
	else
		GroupProgressDB.Players[GroupProgress.MyName].NRemainEventXP = -1;
	end
	local _, Equipped = GetAverageItemLevel();
	GroupProgressDB.Players[GroupProgress.MyName].iLvl = string.format("%.0f",Equipped);
	if ( arg1 == nil ) then GroupProgressDB.Players[GroupProgress.MyName].Lvl = UnitLevel("player");
	else GroupProgressDB.Players[GroupProgress.MyName].Lvl = arg1; end
	local infos = GroupProgressDB.Players[GroupProgress.MyName];
	GroupProgressDB.Players[GroupProgress.MyName].Share = GroupProgress.version.."/"..GroupProgress.MyName.."/"..infos.iLvl.."/"..infos.Lvl.."/"..infos.CurXP.."/"..infos.MaxXP.."/"..infos.Class.."/"..infos.EventXP.."/"..infos.RestXP;
end
function GroupProgress:CalculateMyILevel() -- http://www.wowinterface.com/downloads/info19656-EquippedAverageItemLevelTooltip.html
	local items = {}
	local sum, count
	local unit = "player";
	for i=1, 17, 1 do
		local link = GetInventoryItemLink(unit, i)
		local name, _, quality, itemLevel = GetItemInfo(link or 0)
		local color = select(4, GetItemQualityColor(quality or 1))
		
		if itemLevel and itemLevel > 0 and i ~= 4 then
--			local upgrade = string.match(link, ":(%d+)\124h%[")
			if ( quality == 7 ) then itemLevel = UnitLevel("player"); end
			sum = (sum or 0) + itemLevel 
			count = (count or 0) + 1
			print(name, quality, itemLevel);
		end
	end
	
	if (sum or 0) >= (count or 0) and (count or 0) > 0 then
		return string.format("%.0f", sum/count);
	else
		return ""
	end

end
function GroupProgress:SharingXP() -- ok
	if ( GroupProgressDB.Players[GroupProgress.MyName] ) then
		SendAddonMessage(GroupProgress.AddonPrefix, GroupProgressDB.Players[GroupProgress.MyName].Share, "RAID");
	end
end
function GroupProgress:RequestUpdate()
	SendAddonMessage(GroupProgress.AddonPrefix, "REQUEST_UPDATE", "RAID");
end
function GroupProgress:SharingReceived(msg) -- ok
	if ( msg ) then
		if ( msg == "REQUEST_UPDATE" ) then
			GroupProgress:XPChangedOfMe();
			GroupProgress:SharingXP();
		else
			--print(msg);
			local version, pName, iLvl, Lvl, CurXP, MaxXP, Class, EventXP, RestXP = string.match(msg,"(.+)/(%a+)/(%d+)/(%d+)/(%d+)/(%d+)/(%a+)/(%d+)/(%d+)"); -- "6.0.3.12/Xulos/115/90/100000/100000/DK/5000"
			if ( version and pName and iLvl and Lvl and CurXP and MaxXP and Class and RestXP ) then
				if ( GroupProgressDB.Players[pName] == nil ) then 
					GroupProgressDB.Players[pName] = {};
					GroupProgress:AddPlayerForSharing(pName);
					if ( UnitAffectingCombat("player") == false ) then
						GroupProgress:XPChangedOfMe();
						GroupProgress:SharingXP();
						GroupProgress:InitFrame();
					end
				end
				GroupProgressDB.Players[pName].Name = pName;
				GroupProgressDB.Players[pName].CurXP = CurXP;
				GroupProgressDB.Players[pName].MaxXP = MaxXP;
				GroupProgressDB.Players[pName].EventXP = EventXP;
				GroupProgressDB.Players[pName].RestXP = RestXP;
				GroupProgressDB.Players[pName].Lvl = Lvl;
				GroupProgressDB.Players[pName].iLvl = iLvl
				GroupProgressDB.Players[pName].Class = Class;
				if ( EventXp > 0 ) then
					GroupProgressDB.Players[pName].NRemainEventXP = (MaxXp - CurXP)/EventXp;
				else
					GroupProgressDB.Players[pName].NRemainEventXP = -1;
				end
				GroupProgress:UpdateFrame();
				if ( version > GroupProgress.version ) then
					if ( GroupProgress.alert == nil ) then
						print("YOUR VERSION V"..GroupProgress.version.." IS OLD ! UPDATE IT FOR V"..version.." !");
						GroupProgress.alert = 1;
					elseif ( GroupProgress.alert <=3 ) then
						print("YOUR VERSION IS OLD ! UPDATE IT !");
						GroupProgress.alert = GroupProgress.alert + 1;
					end
				end
			end
		end
	end
end
function GroupProgress:AddPlayerForSharing(pName)
	GroupProgress.PartyLst = GroupProgress.PartyLst or {};
	if ( not GroupProgress.PartyLst[pName] ) then
		GroupProgress.PartyLst[pName]=1;
		if ( GroupProgress.CountPlayer ) then
			GroupProgress.CountPlayer = GroupProgress.CountPlayer + 1;
		else
			GroupProgress.CountPlayer = 1;
		end
	end	
end
function GroupProgress:CreateBar(frmName) -- ok
    local PlayerBar = CreateFrame("Button", frmName, MoneyBarsGroupProgressFrame, "GroupProgressBarTemplate");
        
	PlayerBar:RegisterForClicks("AnyUp");
	
	PlayerBar:SetScript("OnClick", GroupProgress_RequestUpdate);
	
	PlayerBar.Pointer = _G[frmName.."Pointer"];
	PlayerBar.PlayerNameLabel = _G[frmName.."PlayerNameLabel"];
	PlayerBar.PlayerNameLevel = _G[frmName.."PlayerNameLevel"];
	PlayerBar.PlayerNameILevel = _G[frmName.."PlayerNameILevel"];
	PlayerBar.PlayerProgress = _G[frmName.."PlayerProgress"];
	
	PlayerBar.StatusBar = _G[frmName.."StatusBar"];
	PlayerBar.StatusBar:SetValue(100);
	PlayerBar.StatusBar:SetMinMaxValues(0, 100);
   
    PlayerBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    PlayerBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	PlayerBar.BtnDown = false;
	
	return PlayerBar;
end
function GroupProgress:InitFrame() -- ok
	if ( #GroupProgress.BARRES ~= GroupProgress.CountPlayer or #GroupProgress.BARRES == 0 ) then
		local idx = 1;
		for k, v in pairs(GroupProgress.PartyLst) do 
			if ( k and v ) then 
				local frmName = "GroupProgressBar"..tostring(idx);
				if ( _G[frmName] == nil ) then -- si la barre a pas encore t cr on la cr / permet de s'assurer qu'on aura tujours un nombre de barres suffisant et en corlation avec la fenetre
					local Bar = GroupProgress:CreateBar(frmName);
					--Bar:Hide(); provoquera des bug en combat vaut mieux la rendre transaprante en modifiant les porprits de ses enfants
					GroupProgress.BARRES[idx] = Bar;
				end
				idx = idx + 1;
			end
		end 
	
		local offset = 5;
		local mFrameContainer = GroupProgressFrame;
		local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
		nrowMax = math.ceil(#GroupProgress.BARRES);
		mFrameContainer:SetWidth(GroupProgressDB.Params.PlayerBarWidth);
		local mFrameWidth = mFrameContainer:GetWidth() - offset;
		itW = mFrameWidth - offset;
		itH = GroupProgressDB.Params.PlayerBarHeight;
		local heightMax = nrowMax * itH + offset*(nrowMax+1);
		mFrameContainer:SetHeight(heightMax);
		local mFrameHeight = mFrameContainer:GetHeight() - offset;
		
		local Row, Col = 0, 0;
		for idx, guiBar in pairs(GroupProgress.BARRES) do
			if ( guiBar ) then
				guiBar:SetParent(mFrameContainer);
				Row = math.floor((idx-1));
				Col = (idx-1)- Row;
				TopLeftX = Col * itW + offset*(Col+1);
				TopLeftY = Row * itH * -1 - offset*(Row+1);
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", TopLeftX, TopLeftY);
				guiBar:SetWidth(itW);
				guiBar:SetHeight(itH);
			end
		end
	end
end
function GroupProgress:ResetBar(GuiBar) -- ok
	if ( GuiBar ) then
		GuiBar.Pointer:SetTexture(nil);
		GuiBar.PlayerNameLabel:SetText("");
		GuiBar.PlayerNameLevel:SetText("");
		GuiBar.PlayerNameILevel:SetText("");
		GuiBar.PlayerProgress:SetText("");
		GuiBar.StatusBar:SetValue(0);
		GuiBar.StatusBar:SetMinMaxValues(0, 100);
		GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
		GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
		GuiBar.BtnDown = false;
	end
end
function GroupProgress:FormatAmountToPercentValue(val, precision, total)
	if ( val and precision and total ) then
		local percentVal = (val*100)/total;
		return tonumber(string.format("%."..tostring(precision).."f", percentVal));
	else
		return -1;
	end
end
function GroupProgress:GetColorCodeFromRGB(red, green, blue) -- de 0  1 en float
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFA"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function GroupProgress:GetColorCodeFromRGBStruct(rgbStruct) -- de 0  1 en float
	local codeWow = GroupProgress:GetColorCodeFromRGB(rgbStruct.r, rgbStruct.g, rgbStruct.b);
	return codeWow; 
end
function GroupProgress:UpdateFrame() -- ok
	local PlayerListToSort = {};
	for playerIndexer, val in pairs(GroupProgress.PartyLst) do
        if ( playerIndexer and val ) then 
			tinsert(PlayerListToSort, playerIndexer);
        end
    end
	sort(PlayerListToSort);
	for i, bar in pairs(GroupProgress.BARRES) do
		if ( bar ) then
			GroupProgress:ResetBar(bar);
		end
	end
	local idx = 1;
    for index, playerIndexer in pairs(PlayerListToSort) do
		if ( playerIndexer ) then
            local GuiBar = GroupProgress.BARRES[idx];
			idx = idx + 1;
            if ( GuiBar ) then
                local frmName = GuiBar:GetName();
				local infos = GroupProgressDB.Players[playerIndexer];
				if ( infos ) then
					GuiBar.Name = playerIndexer;
					local codeColor = "";
					if ( infos.Class ) then
						local classR, classG, classB =  
							RAID_CLASS_COLORS[infos.Class].r, 
							RAID_CLASS_COLORS[infos.Class].g,
							RAID_CLASS_COLORS[infos.Class].b;
						GuiBar.StatusBar:SetStatusBarColor(classR, classG, classB, 1);
						codeColor = GroupProgress:GetColorCodeFromRGB(classR, classG, classB) or "";
					end
					GuiBar.PlayerNameLabel:SetText(codeColor..infos.Name);
					GuiBar.PlayerNameLevel:SetText(codeColor..tostring(infos.Lvl));
					GuiBar.PlayerNameILevel:SetText(codeColor.."i"..tostring(infos.iLvl));
					local vPercent = GroupProgress:FormatAmountToPercentValue(infos.CurXP, 0, infos.MaxXP);
					GuiBar.PlayerProgress:SetText(tostring(vPercent).."%");
					GuiBar.StatusBar:SetValue(vPercent);
				end
            end
		end
    end
end
